#include <stdio.h>
#include <unistd.h>
#include <SDL.h>
#include <SDL_image.h>
#include <math.h>

#define SLOWDOWN	20000

#define POINT 1
#define SNAKE 2
#define PACMAN 3
#define PIXEL 4
#define BLOOD 5
#define BLOODHALF 6
#define BLOODHALF2 7

#define TRUE 1
#define FALSE 0
#define RICHTUNG int
#define HOCH 1
#define RUNTER -1
#define RECHTS 2
#define LINGS -2


void init();
void paintSinus();
void floatingBlood();
void createW(int n);
void loadPacman();
void cleanArrayFromPacman();
void paint();
void wait();
void setPoints();
void setSnake();
void saveImg();
void update();
void paintExplosion();
void paintPIHalf(int topdown,int layer,int posx,int posy);
void paintPacman(int posx,int posy,int direction);
int getColor(int posx,int posy);
void paintMovingPacman(int posx,int posy,int toposx,int toposy,int direction);
void paintRandom(int posx,int posy,int distanc,int minsize,int maxsize,int n);

SDL_Surface *screen,*imageWPoint,*imageYPoint,*imagePacman[360][15],*imagePacmanPixel,*imagePointPixel,*imageBloodPixel,*bloodHalf,*bloodH2,*imageSnakePixel,*imagePixel;
SDL_Event event;
SDL_Rect rectSnake[10];
SDL_Rect rectPoint[20];
int done = 0;
int fild[115][66];
int pacmanM = 0;
int switching = 0;
float winkel[100];
int hamham =0;
int stophamham = 0;

int main(int argc, char* argv[])
{
	init();
	loadPacman();
	paint();
    //wait();
    SDL_Quit();
    return 0;
}

void init()
{
	// Init video Funktionen fuer sdl
	if (SDL_Init(SDL_INIT_VIDEO) == -1)
	{
		printf("Can't init SDL:  %s\n", SDL_GetError());
		exit(1);
	}

	atexit(SDL_Quit);
	screen = SDL_SetVideoMode(113, 64, 24, SDL_HWSURFACE);
	if (screen == NULL) {
		printf("Can't set video mode: %s\n", SDL_GetError());
		exit(1);
	}

	//Feld auf 0 initialisieren
	int x,y;
	for(x=0;x <113;x++)
		for(y=0;y <64;y++)
			fild[x][y] = 0;

	//Load pixel
	imagePacmanPixel = IMG_Load("images/pacman.png");
	if (imagePacmanPixel  == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	imageSnakePixel = IMG_Load("images/snake.png");
	if (imageSnakePixel   == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	imagePointPixel = IMG_Load("images/point.png");
	if (imagePointPixel    == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	imagePixel = IMG_Load("images/pixel.png");
	if (imagePixel    == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	imageBloodPixel = IMG_Load("images/blood.png");
	if (imageBloodPixel    == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	bloodHalf = IMG_Load("images/bloodhalf.png");
	if (bloodHalf    == NULL)
	{
		printf("Can't load image");
		exit(1);
	}
	bloodH2 = IMG_Load("images/bloodhalf2.png");
	if (bloodH2    == NULL)
	{
		printf("Can't load image");
		exit(1);
	}

	return;
}

void loadPacman()
{
	int i,m;
	char path[100];

	for(i=0;i <360;i++)
	{

		for(m=0;m <16;m++)
		{
			sprintf(path,"images/pacman/16x16/angle-%i/pacman%i.png",i,m);
			imagePacman[i][m] = IMG_Load(path);
			if (imagePacman[i][m] == NULL) {
				printf("Can't load image of %s: %s\n",path,SDL_GetError());
				exit(1);
			}
		}
	}
}

void paint()
{
	int i;

	// Schlange erscheint
	for(i=0;i < 15;i++)
	{
		rectSnake[0].x = 113-i;
		rectSnake[0].y = 6;
		rectSnake[1].x = 113-i;
		rectSnake[1].y = 6-1;

		setSnake();
		update();
	}

	// ersten Punkte setzen
	rectPoint[1].x = 113;
	rectPoint[1].y = 64;
	rectPoint[0].x = 90;
	rectPoint[0].y = 30;
	setPoints();
	update();

	// Schlange geht bis ersten Punkt
	for(i;i <= 23;i++)
	{
		rectSnake[0].x = 113-i;
		rectSnake[0].y = 6;
		rectSnake[1].x = 113-i;
		rectSnake[1].y = 6-1;

		setSnake();
		update();
	}

	// Schlange geht nach unten und frisst ersten Punkt
	for(i=1;i <= 30;i++)
	{
		rectSnake[0].x = 113-23;
		rectSnake[0].y = 6+i;
		rectSnake[1].x = 113-22;
		rectSnake[1].y = 6+i;

		setSnake();
		update();
	}

	// zweiten Punkte setzen
	rectPoint[1].x = 113;
	rectPoint[1].y = 64;
	rectPoint[0].x = 90;
	rectPoint[0].y = 45;
	setPoints();
	update();

	// Schlange geht nach unten und frisst zweiten Punkt
	for(i=30;i <= 44;i++)
	{
		rectSnake[0].x = 113-23;
		rectSnake[0].y = 6+i;
		rectSnake[1].x = 113-22;
		rectSnake[1].y = 6+i;

		setSnake();
		update();
	}

	rectPoint[0].x = 113;
	rectPoint[0].y = 64;
	rectPoint[1].x = 113;
	rectPoint[1].y = 64;
	rectPoint[2].x = 30;
	rectPoint[2].y = 50;

	// Pacman setzen
	fild[rectPoint[2].x][rectPoint[2].y] = PACMAN;
	fild[rectPoint[2].x+1][rectPoint[2].y] = PACMAN;
	fild[rectPoint[2].x][rectPoint[2].y-1] = PACMAN;
	fild[rectPoint[2].x+1][rectPoint[2].y-1] = PACMAN;

	setPoints();
	update();


	// Schlange geht nach links und frisst pacman
	for(i=90;i >=30 ;i--)
	{
		rectSnake[0].x = i;
		rectSnake[0].y = 49;
		rectSnake[1].x = i;
		rectSnake[1].y = 50;

		setSnake();
		update();
	}

	paintExplosion();

	saveImg();
	saveImg();
	saveImg();
	saveImg();
	saveImg();
	saveImg();
	saveImg();
	saveImg();
}

void wait()
{
	while (!done)
	{
		while (SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = 1;
					break;
			}
		}
	}
}

void setPoints()
{
	int index = 0;
	int count = 0,x,y;
	// Ueberpruefen ob noch Punkte im Feld sind
	//for(x=0;x <113;x++)
		//for(y=0;y <64;y++)
			//	if(fild[x][y] == POINT)
				//	count++;

	// Zwei Punkte setzen
	//if(count == 0)
	//{
		fild[rectPoint[index].x][rectPoint[index].y] = POINT;
		fild[rectPoint[index].x+1][rectPoint[index].y] = POINT;
		fild[rectPoint[index].x][rectPoint[index].y-1] = POINT;
		fild[rectPoint[index].x+1][rectPoint[index].y-1] = POINT;


		fild[rectPoint[index+1].x][rectPoint[index+1].y] = POINT;
		fild[rectPoint[index+1].x+1][rectPoint[index+1].y] = POINT;
		fild[rectPoint[index+1].x][rectPoint[index+1].y-1] = POINT;
		fild[rectPoint[index+1].x+1][rectPoint[index+1].y-1] = POINT;
		index +=2;
	//}


	return;
}

void setSnake()
{
	//printf("setsnake\n");
	fflush(stdout);
	static int countMove = 0;
	static SDL_Rect rect[10000];
	static int len = 16;
	static int onField = 0;
	int eatPoint = FALSE;

	rect[countMove].x = rectSnake[0].x;
	rect[countMove].y = rectSnake[0].y;
	rect[countMove+1].x = rectSnake[1].x;
	rect[countMove+1].y = rectSnake[1].y;

	// Ueberpruefen ob Punkt auf Feld ist auf das sich die schlange setzen will
	if(fild[rectSnake[0].x][rectSnake[0].y] == POINT)
		eatPoint = TRUE;



	//printf("###################################################### %i####%i\n",countMove,eatPoint);
	// Ueberpruefen ob schlange schon voll  sichtbar
	if(len == onField && eatPoint == FALSE)	// Loesche ende
	{
		//printf("Lösche schlange x%i y%i\n",rect[countMove-len].x,rect[countMove-len].y);

		// Loeschen
		fild[rect[countMove-(len*2)].x][rect[countMove-(len*2)].y] = 0;
		fild[rect[countMove-(len*2)+1].x][rect[countMove-(len*2)+1].y] = 0;

		// Setzen
		fild[rectSnake[0].x][rectSnake[0].y] = SNAKE;
		fild[rectSnake[1].x][rectSnake[1].y] = SNAKE;

	}
	else if(len == onField && eatPoint == TRUE)	// nicht loeschen laenge erweitern
	{
		//printf("Erweitere Schlange\n");
		// Setzen
		fild[rectSnake[0].x][rectSnake[0].y] = SNAKE;
		fild[rectSnake[1].x][rectSnake[1].y] = SNAKE;

		len+=2;
		onField+=2;
	}
	else if	(len != onField && eatPoint == FALSE)// noch nicht alle sichtbar
	{
		// Setzen
		fild[rectSnake[0].x][rectSnake[0].y] = SNAKE;
		fild[rectSnake[1].x][rectSnake[1].y] = SNAKE;

		onField++;
	}

	if(eatPoint == TRUE)
		hamham = 1;
	else
		hamham = 0;

	countMove +=2;
	return;
}

void saveImg()
{
	static int  i = 0;
	char name[100];

	if(i / 1000 >= 1)
		sprintf(name,"frames/frame-%i.bmp",i);
	else if(i / 100 >= 1)
		sprintf(name,"frames/frame-0%i.bmp",i);
	else if(i / 10 >= 1)
		sprintf(name,"frames/frame-00%i.bmp",i);
	else
		sprintf(name,"frames/frame-000%i.bmp",i);

	SDL_SaveBMP(screen,name);
	//printf("Save img %s\n",name);
	fflush(stdout);

	if(hamham == 1)
	{
		printf("%i;hamham.wav;0\n",i);
		fflush(stdout);

		hamham = 0;
	}

	if(i == 154)
		stophamham = 10;
	i++;
}

/*
 * Setzt Fertiges Bild aus Array zusammen
 */
void update()
{
	usleep(SLOWDOWN);
	int x,y;
	SDL_Rect rect;

	for(x=0;x < 113;x++)
			for(y=0;y < 64;y++)
			{
				rect.x = x;
				rect.y = y;
				if(fild[x][y] == POINT)
				{
						//printf("Paint Point: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(imagePointPixel, NULL, screen,&rect);
				}
				else if(fild[x][y] == SNAKE)
				{
						//printf("Paint Snake: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(imageSnakePixel, NULL, screen,&rect);
				}
				else if(fild[x][y] == PACMAN)
				{
					//printf("Paint Pacman\n");
					SDL_BlitSurface(imagePacmanPixel, NULL, screen,&rect);
				}
				else if(fild[x][y] == PIXEL)
				{
						//printf("Paint Pixel: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(imagePixel, NULL, screen,&rect);
				}
				else if(fild[x][y] == BLOOD)
				{
						//printf("Paint Blood: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(imageBloodPixel, NULL, screen,&rect);
				}
				else if(fild[x][y] == BLOODHALF)
				{
						//printf("Paint BloodHalf: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(bloodHalf, NULL, screen,&rect);
				}
				else if(fild[x][y] == BLOODHALF2)
				{
						//printf("Paint BloodHalf2: x%i y%i\n",rect.x,rect.y);
						SDL_BlitSurface(bloodH2, NULL, screen,&rect);
				}
				else
						SDL_BlitSurface(NULL, NULL, screen,&rect);
			}

	SDL_UpdateRect(screen, 0, 0, 0, 0);
	saveImg();
	SDL_FillRect(screen,NULL,0x000000);	// surface wieder "cleanen"
	//printf("test\n");
	fflush(stdout);
}

void paintExplosion()
{
	int i,i2=1;
	//1te Stuffe	
	for(i=1;i<16;i++)
	{
		rectSnake[0].x = 30-i;
		rectSnake[0].y = 49;
		rectSnake[1].x = 30-i;
		rectSnake[1].y = 50;
		setSnake();
		update();

		if(i%2 == 0)
		{
			i2++;
			paintPIHalf(1,i2,30,52);
			paintPIHalf(-1,i2,30,48);
			update();
		}
	}

	//Buum
	int pices = 26;
	createW(pices);
	getc(stdin);
	paintRandom(44,52,15,1,3,pices);

	for(i=16;i<50;i+=2)
	{
		paintSinus();
		paintPacman(20+i,42,0);
		update();
	}

	//switching =1;
	//				   x  y   x  y
	paintMovingPacman(70,42,70,0,90);
	paintMovingPacman(70,0,25,0,180);

	paintMovingPacman(25,0,25,20,270);
	paintMovingPacman(25,20,55,20,0);

	paintMovingPacman(55,20,55,50,270);
	paintMovingPacman(55,50,40,50,180);

	paintMovingPacman(40,50,40,38,90);
	paintMovingPacman(40,38,15,38,180);

	paintMovingPacman(15,38,15,23,90);
	paintMovingPacman(15,23,114,23,0);


//	paintMovingPacman(70,42,70,26,90);
//
//	paintMovingPacman(70,26,20,26,180);
//	paintMovingPacman(20,26,20,0,90);
//
//	paintMovingPacman(20,0,63,0,0);
//	paintMovingPacman(63,0,63,14,270);
//
//	paintMovingPacman(63,14,0,14,180);
//	paintMovingPacman(0,14,0,41,270);
//
//	paintMovingPacman(0,41,30,41,0);
//
//	paintMovingPacman(30,41,30,48,270);
//
//	paintMovingPacman(30,48,113,48,0);

}

Uint32 getpixel(int x, int y)
{
    int bpp = screen->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)screen->pixels + y * screen->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

int getColor(int posx,int posy)
{
	Uint8 r,g,b;
	r = g = b = 0;

	SDL_LockSurface (screen);
	Uint32 p = getpixel(posx, posy);

	SDL_PixelFormat *format =  screen->format;
	SDL_GetRGB(p, format, &r, &g, &b);

	SDL_UnlockSurface(screen);


	if(switching == 1)
		printf("Pos:%i,%iRGB:%i,%i,%i!!!!!!!!???????????\n",posx,posy,(int)r,(int)g,(int)b);
	if((r == 255 && g == 255 && b == 0))
		return -1;

	return 1;
}

void paintPacman(int posx,int posy,int direction)
{
	cleanArrayFromPacman();

	if(pacmanM > 15)
		pacmanM = 0;

	SDL_Rect rect;

	rect.x = posx;
	rect.y = posy;

	//printf("Paint Pacman\n");
	SDL_BlitSurface(imagePacman[direction][pacmanM], NULL, screen,&rect);

	pacmanM++;

	int x,y;

	if(stophamham > 0)
		stophamham--;

	for(x=0;x < 113;x++)
			for(y=0;y < 64;y++)
			{
				if(getColor(x,y) == -1)
				{

					if(fild[x][y] != 0)
					{
						if(stophamham <= 0)
						{
							stophamham = 10;
							hamham = 1;
						}
					}
					fild[x][y] = PACMAN;
				}

			}

	SDL_FillRect(screen,NULL,0x000000);
}

void cleanArrayFromPacman()
{
	int x,y;
	for(x=0;x < 113;x++)
				for(y=0;y < 64;y++)
					if(fild[x][y] == PACMAN)
										fild[x][y] = 0;
}

void cleanArraySnakeWB()
{
	int x,y;
	for(x=0;x < 113;x++)
				for(y=0;y < 64;y++)
					if(fild[x][y] == SNAKE || fild[x][y] == PIXEL || fild[x][y] == BLOOD || fild[x][y] == BLOODHALF)
					{
										fild[x][y] = 0;
					}
}

void paintMovingPacman(int posx,int posy,int toposx,int toposy,int direction)
{
	int x;

	if(posx != toposx && posy != toposy)
		printf("ERROR!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
	else if(posx != toposx)
	{

		if(posx > toposx)
			for(x=0;x<fabs(posx-toposx);x+=2)
			{
				// Das Blut muss fliesen muhaaaa ;-)
				floatingBlood();
				paintPacman(posx-x,posy,direction);
				update();
			}
		else
			for(x=0;x<fabs(posx-toposx);x+=2)
			{
				// Das Blut muss fliesen muhaaaa ;-)
				floatingBlood();
				paintPacman(posx+x,posy,direction);
				update();
			}
	}
	else
	{
		if(posy > toposy)
			for(x=0;x<fabs(posy-toposy);x+=2)
			{
				// Das Blut muss fliesen muhaaaa ;-)
				floatingBlood();
				paintPacman(posx,posy-x,direction);
				update();
			}
		else
			for(x=0;x<fabs(posy-toposy);x+=2)
			{
				// Das Blut muss fliesen muhaaaa ;-)
				floatingBlood();
				paintPacman(posx,posy+x,direction);
				update();
			}
	}

}

void paintRandom(int posx,int posy,int distanc,int minsize,int maxsize,int n)
{
	int x,y,i;
	cleanArraySnakeWB();

	for(i=0;i<n;i++)
	{
		x = posx+(rand()*100)%distanc;
		y = posy+(rand()*100)%distanc;

		if(fild[x][y] != PACMAN)
			if(i%2 == 1)
				fild[x][y] = BLOOD;
			else
				fild[x][y] = SNAKE;
	}
}


void paintSinus()
{
	static int frame = 0;
	int x,y,i,newx,newy,count = 0;
	static int aktuell[114][65];

	if(frame == 0)
	{
		// Clear
		for(x=0;x < 113;x++)
			for(y=0;y < 64;y++)
				 aktuell[x][y] = 0;

		// Ermittle aktuelle positionen
		for(x=0;x < 113;x++)
						for(y=0;y < 64;y++)
								aktuell[x][y] = fild[x][y];
	}

	cleanArraySnakeWB();

	// Mit Sinus vom Ursprung aus "Flugbahn" berechnen
	for(x=0;x < 113;x++)
		for(y=0;y < 64;y++)
		{
			if(aktuell[x][y] == BLOOD)
			{
				newx = (int)( x + cos(winkel[count]) * frame);
				newy = (int)(y + sin(winkel[count])* frame);
				fild[newx %113][newy %64] = BLOOD;
				count++;
			}
			else if(aktuell[x][y] == SNAKE)
			{
				newx = (int)(x + cos(winkel[count]) * frame);
				newy = (int)(y + sin(winkel[count]) * frame);
				fild[newx%113][newy%64] = SNAKE;
				count++;
			}
		}

	frame++;

}

void createW(int n)
{
	int i;
	for(i=0;i < n;i++)
	{
		winkel[i] = (float)((int)(rand()*1000) % (int)((int)2000*M_PI))/2000;
		//printf("winkel:%f\n",winkel[i]);
	}
}

void floatingBlood()
{
	int x,y;
	static int count = 0;

	// Zeichne mit schlieren
	//printf("Paint Blood\n");

	if(count >= 2)
	{
		count = 0;

		for(x=113;x > 0;x--)
			for(y=64;y > 0;y--)
			{

				//TODO: Löschen stimmt noch nicht ganz
				if(y == 61 && fild[x][y] == BLOODHALF2)
						fild[x][y] = 0;

				if(y == 62 && fild[x][y] == BLOODHALF)
						fild[x][y] = 0;


				if(y == 63 && fild[x][y] == BLOOD)
						fild[x][y] = 0;

				if(rand()%5 == 1)
				{
					if(fild[x][y] == BLOOD && y+1 <64 && fild[x][y+1] == 0)
					{


							if(y-1 >0 && fild[x][y-1] == BLOODHALF && y-2 >0 && fild[x][y-2] != BLOODHALF2)
							{
								fild[x][1+y] = BLOOD;
								fild[x][y] = BLOODHALF;
								fild[x][y-1] = BLOODHALF2;
							}
							else if(y-1 >0 && fild[x][y-1] == BLOODHALF && y-2 >0 && fild[x][y-2] == BLOODHALF2)
							{
								fild[x][1+y] = BLOOD;
								fild[x][y] = BLOODHALF;
								fild[x][y-1] = BLOODHALF2;
								fild[x][y-2] = 0;
							}
							else
							{
								fild[x][1+y] = BLOOD;
								fild[x][y] = BLOODHALF;
							}

					}
				}
			}
	}
	count++;
}


void paintPIHalf(int topdown,int layer,int posx,int posy)
{
	int i,y,z,x;
	rectPoint[0].x = 113;
	rectPoint[0].y = 64;
	z = layer;
  	for(i=0;i<layer;i++) // Layer
	{
		
		for(x=layer-1-i;x>=0;x--)
		{
			if(topdown == 1)
			{	
				fild[posx-1-x][posy+i] = PIXEL;
				fild[posx][posy+i] = PIXEL;
				fild[posx+1+x][posy+i] = PIXEL;
			}

			if(topdown == -1)
			{	
				fild[posx-1-x][posy-i] = PIXEL;
				fild[posx][posy-i] = PIXEL;
				fild[posx+1+x][posy-i] = PIXEL;
			}
		}
	z--;
	}
}

